#Python tools

In this file three python scripts are available:
- get_matrices.py
- geninput.py
- genmatrix.py

## Get Matrices from the database

This script requires to download the *.pbz2 files from the repository and put them in a local directory.
Using this script, the regular vine matrices representing different regular vines can be 
loaded into a python environment. 
In the example  the directory is specified as "E:/databases_vines/".
The script provides an option to get all matrices in the environment with a particular number of nodes:
```
matrices_4_nodes = get_matrices(matrix_dir, nodes=4)
```
or get all matrices of particular files:
```
matrices_subtrees = get_matrices(matrix_dir, subtrees=['submats_5_T6.pbz2','submats_5_T8.pbz2'])
```
The matrices are returned as an array with matrix classes. Each contains an index, the type and the matrix.

## Generate matrices
The process to generate matrices is split up into 2 parts. 
First the input is created for the actual generation of the matrices using `geninput.py`.
The input can be generated for regular vines with different number of nodes but is limited from 4 to 8. 
If input has run, the following files are created:
- `data_for#.txt`: Output of the input proces, it will show the number of trees
- `alltrees#.pbz2`: This file contains all vines for # nodes
- `treetypes.pbz2`: This file contains sets of isomorphic regular vines
- `tree_dict#.pbz`: Dictionary of the trees 
- `input#.pbz2`: Input file for generation of the matrices and just contains the `alltrees#.pbz2`, `treetypes.pbz2` and `tree_dict#.pbz2`

After the input is created the file `genmatrix.py`, this file reads `input#.pbz2` from the previous step and generate per tree equivalent regular vine the regular vine matrices and output them in different files:
- `submats_#_T#.txt`  wil contain the matrices in ascii format